<template>
  <div>
    <default-spinner-component :loading-message="loadingMessage"
      v-if="loadingData"/>
    <v-container style="margin-top:-20px;">
      <v-layout row justify-space-between
        v-if="loadedData"
        v-bind="gridResponsiveness">
        <v-flex style="margin-top:5px !important;" xs4>
          <v-card style="height:270px;overflow-y:auto;width:96%;margin: 0 auto;"
            class="defaultCardBackground">
            <view-item-details-component/>
          </v-card>
        </v-flex>
        <v-flex style="margin-top:5px !important;" xs4>
          <item-sales-summary :item-sales-data = "itemSalesData"
            style="width:96%;margin: 0 auto;"/>
        </v-flex>
        <v-flex style="margin-top:5px !important;" xs4>
          <v-card style="height:270px;width:96%;margin: 0 auto;"
            class="defaultCardBackground">
            <time-estimation/>
          </v-card>
        </v-flex>
      </v-layout>
      <v-layout row
        justify-space-between
        v-if="loadedData"
        v-bind="gridResponsiveness">
        <v-flex xs8 style="margin-top:20px;">
          <v-card class="defaultCardBackground"
            id="detailsContentSecondary"
            style="width:96%;margin:0 auto;">
            <item-sales-result :item-sales-data = "itemSalesData"/>
          </v-card>
        </v-flex>
        <v-flex xs4 style="margin-top:20px;">
          <v-card style="height:200px;width:96%;margin:0 auto;"
            class="defaultCardBackground">
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
    <br/><br/><br/>
  </div>
</template>
<script>
import axios from 'axios'
import BrandListComponent from './brandInformation.vue'
import DefaultSpinnerComponent from './../common/spinner.vue'
import ViewItemDetailsComponent from './view/viewItemDetails.vue'
import ItemSalesSummary from './view/itemSalesSummary.vue'
import ItemSalesResult from './view/itemSalesResult.vue'
import TimeEstimation from './view/timeEstimation.vue'
export default {
  name: 'ViewItemsComponent',
  data: () => ({
    loadingData: false,
    loadedData: false,
    itemSalesData: []
  }),
  components: {
    BrandListComponent,
    DefaultSpinnerComponent,
    ViewItemDetailsComponent,
    ItemSalesSummary,
    ItemSalesResult,
    TimeEstimation
  },
  computed: {
    loadingMessage () {
      return 'Loading ' + this.$route.params.id + '\'s Data'
    },
    gridResponsiveness () {
      const gridResponsiveness = {}
      if (this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs) gridResponsiveness.column = true
      return gridResponsiveness
    }
  },
  watch: {
    '$route' (to, from) {
      this.populateData()
    }
  },
  methods: {
    populateData () {
      console.log('populate data was called')
      this.loadingData = true
      this.loadedData = false
      axios.get('/item/' + this.$route.params.id)
        .then(response => {
          this.$store.commit('ON_VIEW_ITEM_RESPONSE', response.data)
          return axios.get('/sales_by_item/' + this.$route.params.id)
        }, error => {
          this.loadingData = false
          this.loadedData = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in viewing item: ' + error)
        })
        .then(response => {
          setTimeout(() => {
            this.itemSalesData = response.data
            this.loadingData = false
            this.loadedData = true
          }, 2000)
        }, error => {
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting item sales data: ' + error)
        })
    }
  },
  created () {
    this.populateData()
  }
}
</script>
